﻿local L = LibStub("AceLocale-3.0"):NewLocale("TB_ChatEnhancements", "enUS", true)
if (not L) then return end

local TbCore = TbCore
local strlower = strlower
local strupper = strupper
local strmatch = strmatch
local gsub = gsub
local strfind = strfind
local _player = UnitName("player")
local _possessivePattern = TbCore:GetCaseInsensitivePattern(_player) .. "'?[sSzZ]"
local _reflectivePattern = "(" .. TbCore:GetCaseInsensitivePattern(_player) .. ".-)" .. TbCore:GetHimselfOrHerself("player")
local _verbPattern = "(" .. TbCore:GetCaseInsensitivePattern(_player) .. "%s+)" .. "([%a\128-\255]+)"
local _chefPattern = TbCore:GetCaseInsensitivePattern("Chef " .. _player)

L["DESCRIPTION_METADATA_FIELD"] = "Notes"
L["MENU_SUBHEADER"] = "These options let you pick which chat enhancements to apply.\n"

L["MENU_CHAT_FRAME"] = "Chat Frames"
L["MENU_CHAT_FRAME_DESCRIPTION"] = "Chat frames settings"
L["MENU_CHAT_FRAME_SUBHEADER"] = "Customize your chat frames.\n"
L["MENU_CHAT_EDIT_BOX_LOCATION"] = "Edit box location"
L["MENU_CHAT_EDIT_BOX_LOCATION_DESCRIPTION"] = "Specify whether the input box is located above or below your main chat window."
L["MENU_EXTEND_HISTORY"] = "Extend history"
L["MENU_EXTEND_HISTORY_DESCRIPTION"] = "Extend your chat logs so they may hold up to 8192 entries per window (including your combat log). \n\n\124cff00ffffWARNING\124r: Enabling this feature may clear out your current chat history."
L["MENU_FADE_CHAT"] = "Fade old chat"
L["MENU_FADE_CHAT_DESCRIPTION"] = "Fade text in your chat window after a certain amount of time."
L["MENU_FILTER_CHANNEL_ANNOUNCEMENTS"] = "Hide channel announcements"
L["MENU_FILTER_CHANNEL_ANNOUNCEMENTS_DESCRIPTION"] = "Filter chat channel announcements, such as players joining/leaving channels, or moderation being enabled."
L["MENU_MOUSE_SCROLL"] = "Mouse scrolling"
L["MENU_MOUSE_SCROLL_DESCRIPTION"] = "Enable navigating through your chat windows using the mouse scrolling wheel.\n\nYou may scroll one page a time by holding CTRL, or all the way to the end with SHIFT."
L["MENU_SHOW_CHAT_FRAME_BUTTONS"] = "Show buttons"
L["MENU_SHOW_CHAT_FRAME_BUTTONS_DESCRIPTION"] = "Show the navigation buttons and the language bubble next to your chat windows."
L["MENU_SHOW_CHAT_TIMESTAMPS"] = "Time stamps"
L["MENU_SHOW_CHAT_TIMESTAMPS_DESCRIPTION"] = "Specify whether to add time stamps to every chat entry (including the combat log) and in which format.\n\nYou may shift-click a time stamp to paste it into your chat input box, just like a hyperlink."

L["MENU_TEXT_HIGHLIGHTING"] = "Text Highlighting"
L["MENU_TEXT_HIGHLIGHTING_DESCRIPTION"] = "Text highlighting settings"
L["MENU_TEXT_HIGHLIGHTING_SUBHEADER"] = "Specify words to be highlighted when they appear in chat, and how to highlight them.\n"
L["MENU_LIST_TEXT_HIGHLIGHTING"] = "Keywords"
L["MENU_LIST_TEXT_HIGHLIGHTING_DESCRIPTION"] = "These words will be highlighted in your selected color when they appear in chat. \n\n\124cff00ffffNote\124r: The asterisk * will match any sequence of character, such that 'tele*one' will cause both 'telephone' and 'telefone' to be highlighted."
L["MENU_LIST_TEXT_HIGHLIGHTING_USAGE"] = "<name1>, <name2>, ..."
L["MENU_PICK_COLOR"] = "Pick color"
L["MENU_PICK_COLOR_DESCRIPTION"] = "Pick the color to display your selected keywords in."
L["MENU_TEST_HIGHLIGHTING"] = "Test"
L["MENU_TEST_HIGHLIGHTING_DESCRIPTION"] = "Write all your keywords to your default chat frame."
L["MENU_PER_CLASS_HIGHLIGHTING"] = "Per-class highlighting"
L["MENU_PER_CLASS_HIGHLIGHTING_DESCRIPTION"] = "Highlight the names of players who talk in chat, based on their classes. Custom word highlighting takes precedence over per-class highlighting.\n\n\124cff00ffffNOTE\124r: TB Chat Enhancements needs to learn players' classes before names will start showing up with the appropriate colors. That process is performed automatically over time."

L["TOP"] = "top"
L["BOTTOM"] = "bottom"
L["NONE"] = "None"
L["[12S]"] = "[12:59:59 PM]"
L["12S>"] = "12:59:59 PM>"
L["[24S]"] = "[24:59:59]"
L["24S>"] = "24:59:59>"

L["GOING_AFK_OR_DND"] = "You are now [AD][FN][KD]: (.+)"
L["TARGET_NOT_FOUND"] = format(ERR_CHAT_PLAYER_NOT_FOUND_S, ".+")
L["ROLL_BY"] = "(%.+ Roll %- [0-9]+ for .+ by )([%a\128-\255]+)%f[^%a\128-\255]"
L["DUEL_WIN_PARTIAL"] = "(has defeated )([%a\128-\255]+)( in a duel)"
L["DUEL_FLED_PARTIAL"] = "(has fled from )([%a\128-\255]+)( in a duel)"
L["DUEL_WIN"] = gsub(DUEL_WINNER_KNOCKOUT, "%%%d%$s", "(.+)")
L["DUEL_FLED"] = gsub(DUEL_WINNER_RETREAT, "%%%d%$s", "(.+)")
L["TIPSY"] = format(DRUNK_MESSAGE_OTHER2, ".+")
L["TIPSY_ITEM"] = format(DRUNK_MESSAGE_ITEM_OTHER2, ".+", ".+")
L["DRUNK"] = format(DRUNK_MESSAGE_OTHER3, ".+")
L["DRUNK_ITEM"] = format(DRUNK_MESSAGE_ITEM_OTHER3, ".+", ".+")
L["SOBER"] = format(DRUNK_MESSAGE_OTHER1, ".+")
L["SOBER_ITEM"] = format(DRUNK_MESSAGE_ITEM_OTHER1, ".+", ".+")
L["SMASHED"] = format(DRUNK_MESSAGE_OTHER4, ".+")
L["SMASHED_ITEM"] = format(DRUNK_MESSAGE_ITEM_OTHER4, ".+", ".+")

L["ABBREVIATION_ABSORB"] = "(A: %d)"
L["ABBREVIATION_BLOCK"] = "(B: %d)"
L["ABBREVIATION_CRITICAL"] = "(Crit)"
L["ABBREVIATION_CRUSHING"] = "(C)"
L["ABBREVIATION_GLANCING"] = "(G)"
L["ABBREVIATION_REFLECT"] = "Ref"
L["ABBREVIATION_RESIST"] = "(R: %d)"

L["EMOTE_PARSER"] =
function(frame, e, message, ...)
    --
    -- First see if this emote is about us.
    --
    if (not message or not strfind(message, TbCore:GetCaseInsensitivePattern(_player))) then return end

    --
    -- Substitute possessive forms of our name.
    --
    message = gsub(message, _possessivePattern, "your")

    --
    -- Substitute reflective pronouns.
    --
    message = gsub(message, _reflectivePattern, "%1yourself")

    --
    -- Substitute verbs.
    --
    message = gsub(message, _verbPattern,
        function(lead, verb)
            if (not verb) then return end

            local lower = strlower(verb)
            local replace
            if (lower =="does" or lower == "d0es" or lower == "doez" or lower == "d0ez") then replace = "do"
            elseif (lower == "is" or lower == "iz") then replace = "are"
            elseif (lower == "has" or lower == "haz") then replace = "have"
            else
                replace = strmatch(lower, "([%a\128-\255]+)[sSzZ]%f[^%a\128-\255]")
            end

            if (replace) then
                if (verb == strupper(verb)) then
                    replace = strupper(replace)
                end
                return lead .. replace
            end
        end)

    --
    -- Substitute "Chef Valana" with just "you" for TB Artisan.
    --
    message = gsub(message, _chefPattern, "you")

    --
    -- Replace our name. This needs to be done last since we use our name to match certain patterns.
    --
    message = gsub(message, TbCore:GetCaseInsensitivePattern(_player), "you")
    return nil, message, ...
end
