﻿local L = LibStub("AceLocale-3.0"):NewLocale("TB_ChatEnhancements", "zhTW", false)
if (not L) then return end

L["[12S]"] = "[12:59:59 PM]" -- Requires localization
L["12S>"] = "12:59:59 PM>" -- Requires localization
L["[24S]"] = "[24:59:59]" -- Requires localization
L["24S>"] = "24:59:59>" -- Requires localization
L["ABBREVIATION_ABSORB"] = "A" -- Requires localization
L["ABBREVIATION_BLOCK"] = "B" -- Requires localization
L["ABBREVIATION_CRITICAL"] = "Crit" -- Requires localization
L["ABBREVIATION_CRUSHING"] = "C" -- Requires localization
L["ABBREVIATION_GLANCING"] = "G" -- Requires localization
L["ABBREVIATION_REFLECT"] = "Ref" -- Requires localization
L["ABBREVIATION_RESIST"] = "R" -- Requires localization
L["BOTTOM"] = "bottom" -- Requires localization
L["DESCRIPTION_METADATA_FIELD"] = "Notes" -- Requires localization
L["DRUNK"] = "format(DRUNK_MESSAGE_OTHER3, \".+\")" -- Requires localization
L["DRUNK_ITEM"] = "format(DRUNK_MESSAGE_ITEM_OTHER3, \".+\", \".+\")" -- Requires localization
L["DUEL_FLED"] = "gsub(DUEL_WINNER_RETREAT, \"%%%d%$s\", \"(.+)\")" -- Requires localization
L["DUEL_FLED_PARTIAL"] = "(has fled from )([%a\\128-\\255]+)( in a duel)" -- Requires localization
L["DUEL_WIN"] = "gsub(DUEL_WINNER_KNOCKOUT, \"%%%d%$s\", \"(.+)\")" -- Requires localization
L["DUEL_WIN_PARTIAL"] = "(has defeated )([%a\\128-\\255]+)( in a duel)" -- Requires localization
L["EMOTE_PARSER"] = [=[function(frame, e, message, ...)
    --
    -- First see if this emote is about us.
    --   
    if (not message or not strfind(message, TbCore:GetCaseInsensitivePattern(_player))) then return end

    --
    -- Substitute possessive forms of our name.
    --
    message = gsub(message, _possessivePattern, "your")

    --
    -- Substitute reflective pronouns.
    --
    message = gsub(message, _reflectivePattern, "%1yourself")

    --
    -- Substitute verbs.
    --
    message = gsub(message, _verbPattern,
        function(lead, verb)
            if (not verb) then return end

            local replace
            if (strfind(verb, TbCore:GetCaseInsensitivePattern("does%A")) or strfind(verb, TbCore:GetCaseInsensitivePattern("does$"))) then replace = "do"
            elseif (strfind(verb, TbCore:GetCaseInsensitivePattern("is%A")) or strfind(verb, TbCore:GetCaseInsensitivePattern("is$")) or strfind(verb, TbCore:GetCaseInsensitivePattern("iz%A")) or strfind(verb, TbCore:GetCaseInsensitivePattern("iz$"))) then replace = "are"
            elseif (strfind(verb, TbCore:GetCaseInsensitivePattern("has%A")) or strfind(verb, TbCore:GetCaseInsensitivePattern("has$")) or strfind(verb, TbCore:GetCaseInsensitivePattern("haz%A")) or strfind(verb, TbCore:GetCaseInsensitivePattern("haz$"))) then replace = "have"
            else
                replace = strmatch(verb, "(%a+)s%A")
                if (not replace) then replace = strmatch(verb, "(%a+)s$") end
            end

            if (replace) then return lead .. replace end
        end)
        
    --
    -- Substitute "Chef Valana" with just "you" for TB Artisan.
    --
    message = gsub(message, _chefPattern, "you")

    --
    -- Replace our name. This needs to be done last since we use our name to match certain patterns.
    --
    message = gsub(message, TbCore:GetCaseInsensitivePattern(_player), "you")
    return nil, message, ...
end]=] -- Requires localization
L["GOING_AFK_OR_DND"] = "You are now [AD][FN][KD]: (.+)" -- Requires localization
L["MENU_CHAT_EDIT_BOX_LOCATION"] = "Edit box location" -- Requires localization
L["MENU_CHAT_EDIT_BOX_LOCATION_DESCRIPTION"] = "Specify whether the input box is located above or below your main chat window." -- Requires localization
L["MENU_CHAT_FRAME"] = "Chat frames" -- Requires localization
L["MENU_CHAT_FRAME_DESCRIPTION"] = "Chat frames settings" -- Requires localization
L["MENU_CHAT_FRAME_SUBHEADER"] = [=[Specify which parts of your chat frames will be modified.
]=] -- Requires localization
L["MENU_EXTEND_HISTORY"] = "Extend history" -- Requires localization
L["MENU_EXTEND_HISTORY_DESCRIPTION"] = [=[Extend your chat logs so they may hold up to 8192 entries per window (including your combat log). 

|cff00ffffWARNING|r: Enabling this feature may clear out your current chat history.]=] -- Requires localization
L["MENU_FADE_CHAT"] = "Fade old chat" -- Requires localization
L["MENU_FADE_CHAT_DESCRIPTION"] = "Fade text in your chat window after a certain amount of time." -- Requires localization
L["MENU_FILTER_CHANNEL_ANNOUNCEMENTS"] = "Hide channel announcements" -- Requires localization
L["MENU_FILTER_CHANNEL_ANNOUNCEMENTS_DESCRIPTION"] = "Filter chat channel announcements, such as players joining/leaving channels, or moderation being enabled." -- Requires localization
L["MENU_LIST_TEXT_HIGHLIGHTING"] = "Keywords" -- Requires localization
L["MENU_LIST_TEXT_HIGHLIGHTING_DESCRIPTION"] = "These words will be highlighted in your selected color when they appear in chat." -- Requires localization
L["MENU_LIST_TEXT_HIGHLIGHTING_USAGE"] = "<name1>, <name2>, ..." -- Requires localization
L["MENU_MOUSE_SCROLL"] = "Mouse scrolling" -- Requires localization
L["MENU_MOUSE_SCROLL_DESCRIPTION"] = [=[Enable navigating through your chat windows using the mouse scrolling wheel.

You may scroll one page a time by holding CTRL, or all the way to the end with SHIFT.]=] -- Requires localization
L["MENU_PARTIAL_MATCHES"] = "Partial Matches" -- Requires localization
L["MENU_PARTIAL_MATCHES_DESCRIPTION"] = "Allow partial matches for text highlighting. Words will be highlighted even if they do not match any of your keywords exactly, but only contain at least one of them." -- Requires localization
L["MENU_PER_CLASS_HIGHLIGHTING"] = "Per-class highlighting" -- Requires localization
L["MENU_PER_CLASS_HIGHLIGHTING_DESCRIPTION"] = [=[Highlight the names of players who talk in chat, based on their classes. Custom word highlighting takes precedence over per-class highlighting.

|cff00ffffNOTE|r: TB Chat Enhancements needs to learn players' classes before names will start showing up with the appropriate colors. That process is performed automatically over time.]=] -- Requires localization
L["MENU_PICK_COLOR"] = "Pick color" -- Requires localization
L["MENU_PICK_COLOR_DESCRIPTION"] = "Pick the color to display your selected keywords in." -- Requires localization
L["MENU_SHOW_CHAT_FRAME_BUTTONS"] = "Show buttons" -- Requires localization
L["MENU_SHOW_CHAT_FRAME_BUTTONS_DESCRIPTION"] = "Show the navigation buttons and the language bubble next to your chat windows." -- Requires localization
L["MENU_SHOW_CHAT_TIMESTAMPS"] = "Time stamps" -- Requires localization
L["MENU_SHOW_CHAT_TIMESTAMPS_DESCRIPTION"] = [=[Specify whether to add time stamps to every chat entry (including the combat log) and in which format.

You may shift-click a time stamp to paste it into your chat input box, just like a hyperlink.]=] -- Requires localization
L["MENU_SUBHEADER"] = [=[These options let you pick which chat enhancements to apply.
]=] -- Requires localization
L["MENU_TEST_HIGHLIGHTING"] = "Test" -- Requires localization
L["MENU_TEST_HIGHLIGHTING_DESCRIPTION"] = "Write all your keywords to your default chat frame." -- Requires localization
L["MENU_TEXT_HIGHLIGHTING"] = "Text highlighting" -- Requires localization
L["MENU_TEXT_HIGHLIGHTING_DESCRIPTION"] = "Text highlighting settings" -- Requires localization
L["MENU_TEXT_HIGHLIGHTING_SUBHEADER"] = [=[Specify words to be highlighted when they appear in chat, and how to highlight them.
]=] -- Requires localization
L["NONE"] = "None" -- Requires localization
L["ROLL_BY"] = "(%.+ Roll %- [0-9]+ for .+ by )([%a\\128-\\255]+)%f[^%a\\128-\\255]" -- Requires localization
L["SMASHED"] = "format(DRUNK_MESSAGE_OTHER4, \".+\")" -- Requires localization
L["SMASHED_ITEM"] = "format(DRUNK_MESSAGE_ITEM_OTHER4, \".+\", \".+\")" -- Requires localization
L["SOBER"] = "format(DRUNK_MESSAGE_OTHER1, \".+\")" -- Requires localization
L["SOBER_ITEM"] = "format(DRUNK_MESSAGE_ITEM_OTHER1, \".+\", \".+\")" -- Requires localization
L["TARGET_NOT_FOUND"] = "format(ERR_CHAT_PLAYER_NOT_FOUND_S, \".+\")" -- Requires localization
L["TIPSY"] = "format(DRUNK_MESSAGE_OTHER2, \".+\")" -- Requires localization
L["TIPSY_ITEM"] = "format(DRUNK_MESSAGE_ITEM_OTHER2, \".+\", \".+\")" -- Requires localization
L["TOP"] = "top" -- Requires localization

